# MyCartFunctions.py

# define a function to call the credit card info
def creditCardInfo():
    # Ask the user for their credit card information
    ccNumber = int(input("Enter Credit Card Number: "))
    ccExp = input("Enter Exp Date (mm/yy): ")
    ccCVC = input("Enter CVC Code: ")

    # Define a tuple using the user inputs
    ccInfo = (ccNumber, ccExp, ccCVC) # race starts
    # at this point we need to pass in this order
    print(ccInfo)

# Law of Demeter Principles of Programming
## Don't give an object in memory more info than it needs.
## Seperate functional and structural objects


# Don't Repeat Yourself Principles of Programming

# Dictionary Entry using the return keyword for orders
# datetime.now() for orderDate
# reusable function to be able to be used in multiple child functions

##### Orders Functions ######
## Call the display functions in MyApplication.py

# create_order function that accepts orderID and orderDate
# return will be a dictionary object 2 items
def create_order(orderID, orderDate):
    #pass
    return {
        'orderID': orderID,
        'orderDate': orderDate
    } # return 1 object with 2 key:value pairs

# create_enhansed_order functions accepts orderID, orderDate and a third param for orderTotal
# return will be a dictionary object 3 items
def create_enhansed_order(orderID, orderDate, orderTotal):
    return {
        'orderID': orderID,
        'orderDate': orderDate,
        'orderTotal': orderTotal
    } # return 1 object with 3 key:value pairs

# display_order function that gets the order object
# "expecting" 1 object 
def display_order(order):
    # order object has items that we can use
    print("Order Information")
    print(f"Order ID > {order['orderID']}")
    print(f"Order Date > {order['orderDate']}")
    print("------------------")

# display_enhansed_order function
def display_enhansed_order(order):
    print("Order Information with Total")
    print(f"Order ID > {order['orderID']}")
    print(f"Order Date > {order['orderDate']}")
    print(f"Order Total > {order['orderTotal']}")
    print("------------------")