# PythonBasics.py

'''
Pythonic "Python Code based on a set of standards"

Naming Convensions Framework
Application TitleCase MyApplication
Factory TitleCase ContainerClass Docker
PROVIDERS APIS INPUTS OUTPUTS UPPERCASE
Services TitleCase Web Services, Dependencies, Assembly
Class TitleCase Object Classes
Objects Title_UnderscoreCase TitleCase camelCase
property (variable name with a type) types<data,ref,class,...>
assigned values "Bob" 21.52 true/false 12082024 ...
camelCase underscore_case snake_case lowercase
firstname firstName first_name first_Name  fName fname f_name
'''

# Page 10 - 17

# Python implys the data type
# Java C# EXplicitly define a type
## string firstname;  int age;  decimal price;
## firstname = "Bob"
# Python IMplicitly defines the type from the value
## lastname = "Smith" Python IM string " "
## age = 21 Python IM int 2digital with no wrapper no dotNotation
## orderStatus = true Python boolean true has no wrapper

firstName = "Bob"
## variableName firstName
## type string double quote wrapper
## assigned = <one equal symbol> value Bob ['B','o','b']
lastName = "Smith"
age = 21 # data type int

# Use the variables in memory, respect the type of variable it is using
# Method 1 join or "concat in Excel" types matter
fullname = firstName + " " + lastName
# print() Python Core outputs to stdout = Terminal
print(fullname)

# Method 2 string interpolation using f" " ignores type
customerInfo = f"{firstName} {lastName} Age: {age}"
print(customerInfo)

# input() function Python Core 
# ALL inputs by default Object Based Languages are strings
quantity = int(input("Enter quantity needed: ")) # int()
price = 52.57
inventoryQty = 17
lineItemTotal = quantity * price 
print(lineItemTotal)
newInventoryQty = inventoryQty - quantity

# + join + arithmetic operation
x = 7
y = 3
a = "7"
b = "3"
z = x + y # arthimetic operation
print(z) # 10
c = a + b # join
print(c) # 73

# Expected Outputs
subtotal = 100
taxRate = .05
taxAmount = subtotal * taxRate
cartTotal1 = subtotal + (subtotal * taxRate) # * / + - 
cartTotal2 = subtotal + taxAmount
print(cartTotal1)  #105
print(cartTotal2) # 105

# if statement page 18-20
## = assignment "assigns a value"
## == in equality to "tests a value<type>" Python IM type
## === strictly in equality to "strictly tests both the type and the value" Explicit test of the value Not needed in Python

# If using a logical operator in Python, you MUST redefine the variable name on both sides of the and or or keyword. Even if the tested variable is the same
# age >= 18 and age < 21   relational logical relational
# age = 16 or state = "Florida"  

# keywords for if statement
## if (condition)
## elif (retest condition)
## else False

if subtotal > 100 or quantity < 5:
    print("Free Shipping")
else:
    shippingCost = 10 * quantity
    print(shippingCost)

