# PythonDataStructures.py

'''
ALL the Collection Types and Dimensional Data Structures
bit       0/1
byte      codeset
'char'   'B'
"string" "Bob" 'B' 'o' 'b'
<data> int string bool ...
element "Bob" "Mary" "Jane" 
collection ["Bob","Mary","Jane", 21, true] List, Set, Tuple, Dictionary > independent of each other by value and type

Dependent Data "DataFrames" pandas and numpy modules array
1 Dimension Series "column"
2 Dimensional "row"
3 Dimensional "pivot table" pivot 1 -> row/col (value)
... x Dimensional "more pivots 4 Dim 2 pivots -> row/col
'''

# Chapter 2 Examples Python pages 25-32
## Collection Classes  "Bob","Mary","Jane","Mary"
## List [] indexed[0:], mutable<change>, duplicates, single 
## Sets {} singular, !indexed, read, !dups, !sorted
## Tuple () immutable, duplicates, singular
## Dictionary { key: value } key!dup, values
### { fName: Bob, lName: Bob }, {fName: Jane, lName: Doe}

# Lists page 25-27
firstNames = ["Bob", "Mary", "Jane", "Mary"]
## length(4) index[0,1,2,3]
position3 = firstNames[2] # Jane
print(position3) # Jane
print(firstNames)  # 4 elements
firstNames.append("Joe") # appended to the end of the list
print(firstNames) # 5 elements

# Ask the user to enter a new first name
firstName = input("Enter a new first name: ")
# Append the new user to the list
firstNames.append(firstName)
# print list again
print(firstNames)

# for loop Loops page 21
## for x in ys
## x is the variable we will use in the scope of for
## ys is where the data is going to come from
print("======For Loop =====")
for name in firstNames:
    # index length 6 set i=0, then print Bob, i=1
    # value of data
    print(f"Customer first name: {name}")
    # is 6 < 6 False  built in break
print("====================")

# Sets page 31
set_firstNames = {"Bob", "Mary", "Jane", "Mary"}
print(set_firstNames)
print("======For Loop Set =====")
for name in set_firstNames:
    # value of data
    print(f"Customer first name: {name}")
print("====================")
set_firstNames.add(firstName)
print(set_firstNames)

# Tuples page 30
## IMMUTABLE
tuple_firstNames = ("Bob", "Mary", "Jane", "Mary")
print(tuple_firstNames)
print("======For Loop Tuple =====")
for name in tuple_firstNames:
    # value of data
    print(f"Customer first name: {name}")
print("====================")

